'use strict'

const expect = require('chai').expect

const rewire = require('rewire')
const _mysql = rewire('../index') // rewire the module
const mysql = _mysql() // initialize the module

const incCounter = _mysql.__get__('incCounter')
const resetCounter = _mysql.__get__('resetCounter')


describe('Serverless MySQL Unit Tests', function() {

  describe('Counter', function() {

    it('should return the current counter', function() {
      expect(mysql.getCounter()).to.equal(0)
    })
    it('should increment the counter by 1', function() {
      incCounter()
      expect(mysql.getCounter()).to.equal(1)
    })
    it('should reset the counter', function() {
      resetCounter()
      expect(mysql.getCounter()).to.equal(0)
    })

  }) // end counter

})
